// FiveWin Object Inspector - Warning: Under development! But try it!

#include "FiveWin.ch"
#include "ObjInsp.ch"

//----------------------------------------------------------------------------//

function Main()

   local oWnd

   DEFINE WINDOW oWnd FROM 1, 1 TO 20, 75 TITLE "Inspecting Objects"

   SET MESSAGE OF oWnd TO "Press right button to inspect me"

   ACTIVATE WINDOW oWnd ;
      ON RIGHT CLICK OInspect( oWnd )

return

//----------------------------------------------------------------------------//

function OInspect( oObject )

   local oDlg, oLbx, oSay
   local cProp := ""
   local aObjData, cData, uData
   local n

   DEFINE DIALOG oDlg RESOURCE "Inspector"

   REDEFINE SAY oSay ID ID_LABEL OF oDlg

   aObjData = aOData( oObject )
   for n = 1 to Len( aObjData )
      cData = aObjData[ n ]
      uData = OSend( oObject, cData )
      aObjData[ n ] = PadR( cChr2Data( cData ), 17 ) + Chr( 9 ) + ;
                      ValType( uData ) + "  " + cValToChar( uData )
   next

   REDEFINE LISTBOX oLbx VAR cProp ITEMS aObjData ;
      ID ID_PROPS OF oDlg ;
      ON CHANGE oSay:cTitle := cProp

   ACTIVATE DIALOG oDlg CENTERED

return

//----------------------------------------------------------------------------//
